SystemOrganization addCategory: #Deli!

WASession subclass: #DLSession
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli'!

!DLSession methodsFor: 'computing' stamp: 'Marik 5/20/2009 17:09'!
isLoggedIn

	^self user isNil not! !

!DLSession methodsFor: 'computing' stamp: 'Marik 5/20/2009 17:09'!
login: aUser

	self user: aUser! !

!DLSession methodsFor: 'computing' stamp: 'Marik 5/20/2009 17:09'!
logout

	self user: nil.! !

!DLSession methodsFor: 'accessing' stamp: 'Marik 5/20/2009 17:08'!
user

	^ user! !

!DLSession methodsFor: 'accessing' stamp: 'Marik 5/20/2009 17:08'!
user: anObject

	user := anObject.! !

WATask subclass: #DLRootTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli'!

!DLRootTask class methodsFor: 'registration' stamp: 'Marik 5/20/2009 16:12'!
canBeRoot

	^true! !

!DLRootTask methodsFor: 'processing' stamp: 'Marik 5/20/2009 17:13'!
go

	|loginAnswer|
	loginAnswer := self call: DLLoginComp new.
	loginAnswer
		ifNotNil: [
			self session login: loginAnswer.
			self call: DLDashComp new]! !

Object subclass: #DLUser
	instanceVariableNames: 'userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli'!

!DLUser methodsFor: 'initialize-release' stamp: 'Marik 5/20/2009 16:53'!
initialize

	super initialize.! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/20/2009 13:16'!
userName

	^ userName! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/20/2009 13:16'!
userName: anObject

	userName := anObject.! !

Object subclass: #Tutorials
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli'!

!Tutorials methodsFor: 'as yet unclassified' stamp: 'Marik 5/19/2009 17:41'!
HowToUseHPILogin

"
--> Load LDAPlayer v47 via SqueakMapPackageLoader
--> Load HPILogin class via Monticello from Repository http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/HPILogin

--> Use

hpi := HPILoginChecker new.
hpi checkLogin: 'surname.name' password: '******'"! !

WAComponent subclass: #DLDashComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli'!

!DLDashComp methodsFor: 'rendering' stamp: 'Marik 5/20/2009 17:14'!
renderContentOn: html

	html 	heading: 'Dash';
			break;
			text: 'Willkommen ', self session user userName! !

WAComponent subclass: #DLLoginComp
	instanceVariableNames: 'userName password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli'!

!DLLoginComp methodsFor: 'computing' stamp: 'Marik 5/20/2009 16:56'!
acceptUser

	|user|
	user := DLUser new.
	user userName: self userName.
	self 	clearUserData;
			answer: user! !

!DLLoginComp methodsFor: 'computing' stamp: 'Marik 5/20/2009 17:16'!
clearUserData

	self 	userName: nil;
			password: nil! !

!DLLoginComp methodsFor: 'computing' stamp: 'Marik 5/20/2009 16:56'!
denyUser

	self 	clearUserData;
			answer: nil! !

!DLLoginComp methodsFor: 'computing' stamp: 'Marik 5/20/2009 16:38'!
hashPassword: aPassword

	aPassword 	ifEmpty: [^0]
					ifNotEmpty: [^SecureHashAlgorithm new hashMessage: aPassword]! !

!DLLoginComp methodsFor: 'accessing' stamp: 'Marik 5/20/2009 16:30'!
password

	^ password! !

!DLLoginComp methodsFor: 'accessing' stamp: 'Marik 5/20/2009 16:30'!
password: anObject

	password := anObject.! !

!DLLoginComp methodsFor: 'rendering' stamp: 'Marik 5/20/2009 16:34'!
renderContentOn: html

	html 	heading: 'Login to the Deli System'.
			html 	form: [
			html 	table: [
					html 	tableRow: [self renderNameInputOn: html];
							tableRow: [self renderPasswordInputOn: html];
							tableRow: [self renderSubmitButtonOn: html]]].! !

!DLLoginComp methodsFor: 'rendering' stamp: 'Marik 5/20/2009 16:30'!
renderNameInputOn: html

	html 	tableData: [html text: 'Name: '];
			tableData: [html textInput on: #userName of: self]! !

!DLLoginComp methodsFor: 'rendering' stamp: 'Marik 5/20/2009 16:46'!
renderPasswordInputOn: html

	html 	tableData: [html text: 'Password: '];
			tableData: [html passwordInput on: #password of: self]

"password bisher plain, vielleicht sowas? callback: [:value | self password: (self hashPassword: value)]]"! !

!DLLoginComp methodsFor: 'rendering' stamp: 'Marik 5/20/2009 16:41'!
renderSubmitButtonOn: html

	html tableData: [html submitButton 	callback:[self validateLogin];
													text: 'Login']
! !

!DLLoginComp methodsFor: 'accessing' stamp: 'Marik 5/20/2009 16:30'!
userName

	^ userName! !

!DLLoginComp methodsFor: 'accessing' stamp: 'Marik 5/20/2009 16:30'!
userName: anObject

	userName := anObject.! !

!DLLoginComp methodsFor: 'computing' stamp: 'Marik 5/20/2009 16:51'!
validateLogin

	|loginChecker|
	loginChecker := HPILoginChecker new.
	(loginChecker checkLogin: self userName password: self password)
		ifTrue:[self acceptUser]
		ifFalse:[self denyUser]! !
